Subject: Adding an UnlessViewHelper convenience

Description

AFAIK, you currently have to do something like this if you want to conditionally display something if it is not the case:

<f:if condition="{...}">
<f:ithen></f:then>
<f:else>
| just want this to be displayed and don't need the "if true case".
</f:else>
</fif>

Peeking at ruby, I think some syntactic sugar could simplify this:

<f:unless condition="{...}">
<f:ithen>| like this</f:then>
</fiunless>

This, of course, also accepts an else block. With this, however, you'll have the same amount of markup, but it may integrate better into
your view logic.

<f:unless condition="{...}">
<f:ithen>not the case</fithen>
<f:else>the case</f:else>
</fiif>

If this does not encounter much resistance, I'd like to submit a patch.

Related issues:
related to TYPOS3.Fluid - Feature # 52640: Create an UnlessViewHelper as oppos... Under Review 2013-10-09

History

#1 - 2013-02-27 10:04 - Pascal Diirsteler

Just saw that it also may work this way:

<f:if condition="{...}">

<felse>...</f:else>
</fiif>
I think an UnlessViewHelper would still be the better choice regarding readability, though.

#2 - 2013-08-07 17:47 - Stefan Neufeind

Background for "unless" is that Ruby knows "unless" as a negation of "if". Hmm, or "f:if.not" maybe?

#3 - 2013-10-12 17:12 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.0rg/24633

#4 - 2013-10-27 12:12 - Anja Leichsenring

| am fine with unless, but not with the implementation as is. Better to reverse the if VH. No shorthand syntax for this is not the way.

consider this use case:

<f:for each="{entries} as="entry" iteration="foo">
<li class="{f:unless (condition:foo.isLast, then: 'list_entry', else:'list_entry_last)}"></li>

</f:for>

If noone objects, | will push a new patchset reversing the if VH. Let me know what you think.

#5 - 2014-09-12 10:42 - Alexander Opitz
- Project changed from Fluid to Core
- Category changed from Fluid: ViewHelpers to Fluid

- Assigned To set to Anja Leichsenring

#6 - 2015-01-06 21:47 - Wouter Wolters

- Status changed from Under Review to Closed

Fluid make the compiler work with this. https:/review.typo3.org/#/c/31707/
